import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;

public class Avatar extends SmoothMover
{

    private int alfa = 0;// angolo da raggiungere
    private int beta = 0;// angolo intermedio per raggiungere alfa
    private int TURN_SPEED ;
    private int MOVE_SPEED ;
    private int DELTA_X=6;
    private int DELTA_Y=6;
    private Vector s;
    public double x_t,y_t; // coordinate posizione finale
    public double x_s,y_s; // coordinate eventuale posizione intermedia
    //private Arrow arrow = null;
    private int die_count = 0;
    private int size = 0;
    GreenfootImage img=null;
    int delta = 1;

    public boolean isDieing ()
    {
        if(die_count > 0)
            return true;
        return false;
    } 

    public void die()
    {
        die_count++;
        if(null == img)
            img = getImage();

        int w = img.getWidth();
        int h = img.getHeight(); 

        if( size > 30)
            delta = -1;
        if(size < 1)
            delta = 1;

        size = size + delta;
        w = w + delta;
        h = h + delta;
        img.scale(w, h);   
        setImage(img);
        if(   die_count > 500)
            {
            World wrd = getWorld();
            wrd.removeObject(this);
            }
    }

    public Avatar(int turn_speed, int move_speed)
    {
        TURN_SPEED = turn_speed;
        MOVE_SPEED = move_speed; 
    }

    public boolean isObstacle(java.lang.Class cls)
        {
        Actor actor = getOneIntersectingObject( cls)  ;
        if(actor == null) 
            return false;
        return true;
        }

    public boolean isOutOfWorld()
        {// test for outside border
        int x,y;
        x = getX(); y=getY();
        World myWorld = getWorld();
        if ( x >= (myWorld.getWidth()-1) || y >= (myWorld.getHeight()-1) ) 
            {
            // evito di ricadere in questa condizione
            int x1,y1;
            if (x >= (myWorld.getWidth()-1) )
                x1 = myWorld.getWidth()-20;
            else
                x1=x;
            if (y >= (myWorld.getHeight()-1) )
                y1= (myWorld.getHeight()-20);
            else
                y1=y;
            //////////////////////
            return true;
            }
        else if (x <= 0 || y <= 0)
            {
            // evito di ricadere in questa condizione
            int x1,y1;
            if (x <= 0)
                x1=20;
            else
                x1=x;
            if (y <= 0)
                y1=20;
            else
                y1=y;
            //////////////////////

            setLocation(x1, y1);
 
            return true;
            }
        return false;
        }

    public Vector  getNewDirection()
        {
        Vector s = new Vector((double)getX(), (double)getY()) ;
        Vector t = new Vector(s.getDirection()+90, 50);
        //s.add(t);
        //Vector u = new Vector((double)(t.getX()+getX()), (double)(t.getY()+getY()));
        //u.scale( MOVE_SPEED/u.getLength() );
        //setMovement( s);
        return t;
        }

    public void rotateAvatar()
        {// eseguo rotazione 
  
            beta = beta + TURN_SPEED;
            
            // se alfa e beta molto vicini, li considero uguali
            if(Math.abs(alfa-beta) <= Math.abs(TURN_SPEED) )
               beta = alfa;
            
            // beta sempre [0..360]
            beta = beta % 360;
            if(beta < 0)
                beta = 360 + beta;
                
            setRotation(beta);    
            //myLabel.setText("alfa:"+alfa+" beta:"+beta);       
        }

    public boolean isAvatarToRotate()
        {
        return (beta != alfa);
        }

    public boolean isStopAvatarNow(double x, double y)
    {
        if( 
            ( (x - DELTA_X <= getX() ) && ( getX() <= x + DELTA_X) )
            && 
            ( (y - DELTA_Y <= getY() ) && ( getY() <= y + DELTA_Y) )
            )  // ho raggiunto la destinazione ?
            return true;
        return false;
    }

    /*ublic void setArrow(double dx, double dy)
    {
     
     if(arrow != null)
        {
        getWorld().removeObject(arrow);
        arrow = null;
        }
     arrow = new Arrow((int)dx, (int)dy);
     getWorld().addObject(arrow, getX(), getY());   
     alfa = arrow.getDirection();   
    }*/

    public void setRotationAngle(double x, double y)
        {
        s = new Vector((double)(x-getX()), (double)(y-getY()));
        s.scale( MOVE_SPEED/s.getLength() );
         // calcolo alfa e beta e verso di rotazione
         alfa = s.getDirection();
         if (alfa < 0 )
            alfa =  (360+alfa);
         beta = getRotation();
         int delta = alfa-beta;
         if( delta < 0)
            {
            if( Math.abs(delta) > 360 - Math.abs(delta) )  
             TURN_SPEED = Math.abs(TURN_SPEED); // clockwise
            else
             TURN_SPEED = -Math.abs(TURN_SPEED);// anti-clockwise                   
            }
         else if( delta > 0)
            {
            if( Math.abs(delta) > 360 - Math.abs(delta) )  
             TURN_SPEED = -Math.abs(TURN_SPEED); // clockwise
            else
             TURN_SPEED = Math.abs(TURN_SPEED);// anti-clockwise                     
            }
        }

    public void setAvatarMovement(double x, double y)
        {
        
        // Calcolo il vettore movimento
        s = new Vector((double)(x-getX()), (double)(y-getY()));
        s.scale( MOVE_SPEED/s.getLength() );
        setMovement( s);
        setRotationAngle(x,y);
        }
}
